#!/usr/bin/perl
####################################################################################################
# Cybercash Gateway Processor                                                   Version 2.0                            
# Copyright 1998  Cybercore Network Solutions, Inc.					    webmaster@superscripts.com                 
# Created 1/12/98                                      					Last Modified 4/21/98                           
####################################################################################################
# COPYRIGHT NOTICE                                                           
# Copyright 1998 Telecore Media International, INC - All Rights Reserved.                    
# http://www.telecore.com                                                                                                            
# Selling the code for this program, modifying or redistributing this software over the Internet or 
# in any other medium is forbidden.  Copyright and header may not be modified
####################################################################################################
require "configure.cgi";
&configure;
####################################################################################################
# END OF USER CONFIGURATION
#####################################################################################################
$date = `$date_command +"%A, %B %d, %Y at %T (%Z)"`; chop($date);
$shortdate = `$date_command +"%D %T %Z"`; chop($shortdate);
$flag = "N";
print "Content-type: text/html\n\n";

#####################################################################################################
&form_parse;
&refergate;
#####################################################################################################
&update;#update password database
print "Password file has been Manually updated\n\n";
exit;
############################################################
# Make sure request is from a valid URL
############################################################
sub refergate {
            
         if ($ENV{'HTTP_REFERER'} =~ /$databaseserver/i) {
			$flag = "OK";
          }
        
        else {
          print "PERMISSION DENIED:  $ENV{'HTTP_REFERER'}";
          exit;
          }        
          
          }   

############################################################
#  REMOVE OLD PASSWORDS
############################################################
sub update {

&todayjulean;

open (EXPIRE, "$expiredatabase");
@users=<EXPIRE>;
close EXPIRE;

foreach $users (@users)  {

($username,$password,$email,$signup,$expire)=split(/\|/,$users);

$crypted = crypt($password,"Gp");

$diff=($today-$signup);
$secretpass = "$username:$crypted\n";
$dummy = "$username|$password|$email\n";

push (@refreshpass,$secretpass) unless ($diff > $expire);
push (@refreshexp,$users) unless ($diff > $expire);
push (@refreshdum,$dummy) unless ($diff > $expire);

                        }

open (PASSWORDS, ">$passwordfile");
flock(PASSWORDS, 2);
foreach $refreshpass (@refreshpass)       {
print PASSWORDS $refreshpass;              }
flock(PASSWORDS, 8);
close (PASSWORDS);

open (EXPIREDATABASE, ">$expiredatabase");
flock(EXPIREDATABASE, 2);
foreach $refreshexp (@refreshexp)       {
print EXPIREDATABASE $refreshexp;              }
flock(EXPIREDATABASE, 8);
close (EXPIREDATABASE);


open (DUMMYFILE, ">$dummyfile");
flock(DUMMYFILE, 2);
foreach $refreshdum (@refreshdum)       {
print DUMMYFILE $refreshdum;              }
flock(DUMMYFILE, 8);
close (DUMMYFILE);


}

############################################################
#  FORM PARSING
############################################################
sub form_parse  {
	read (STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
	@pairs = split(/&/, $buffer);

	foreach $pair (@pairs)
	{
    	($name, $value) = split(/=/, $pair);
    	$value =~ tr/+/ /;
    	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    	$FORM{$name} = $value;
	}}


############################################################
#  DATE ROUTINES
############################################################
sub date	{
	$date=localtime(time);
	($day, $month, $no, $hr, $year) = split (/\s+/,$date);
	$return_date = "$hr, $month $no";
	if ($month =~ /jan/i) {$month=1}     
	elsif ($month =~ /feb/i) {$month=2}  
	elsif ($month =~ /mar/i) {$month=3}  
	elsif ($month =~ /apr/i) {$month=4}  
	elsif ($month =~ /may/i) {$month=5}  
	elsif ($month =~ /jun/i) {$month=6}  
	elsif ($month =~ /jul/i) {$month=7}  
	elsif ($month =~ /aug/i) {$month=8}  
	elsif ($month =~ /sep/i) {$month=9}  
	elsif ($month =~ /oct/i) {$month=10} 
	elsif ($month =~ /nov/i) {$month=11} 
	elsif ($month =~ /dec/i) {$month=12} 
		}

sub todayjulean	{
&date;
	$date=localtime(time);
	@date=split (/\s+/, $date);
	&julean ($month, @date[2], @date[4]);
	$today = $jule;

		}

sub julean{ 
#
# Julean date based on Jan. 1, 1992 being day 1.

$thisdayjulean=0;

@months=(0,31,28,31,30,31,30,31,31,30,31,30,31);

$local_month=$_[0];
$tday=$_[1];
$tyear=$_[2];
$leapdays=((($tyear-1992)/4)+1);     #must be a leap year, so I chose 1992 

# This section drops the remainder of the leap day for the year.
$leapdays2=(($tyear-1992)%4);
$leapdays-=($leapdays2*0.25);
if ($tyear>=2000) {$leapdays-= 1};   #even 100 year years do not have
                                                # leap days in them
$local_thisyear=$tyear-1992;
for ($local_i=1;$local_i<=$local_thisyear;$local_i++) {
                $thisdayjulean+=365;}
for ($local_i=1;$local_i<$local_month;$local_i++) {    #minus 1 because current month not complete
        $thisdayjulean+=@months[$local_i]}
if ($local_month<3 && $leapdays2==0) {$leapdays--};
$thisdayjulean+=$leapdays+$tday;
$jule=$thisdayjulean;
}

sub footer {print "</body></html>";}

sub redirect {
$loc=$_[0];
print"Location: $_ \n\n"; }

sub month_txt   {
($_)=@_;
if ($_==1) {$month_txt = "January"}
elsif ($_==2) {$month_txt="February"}
elsif ($_==3) {$month_txt="March"}
elsif ($_==4) {$month_txt="April"}
elsif ($_==5) {$month_txt="May"}
elsif ($_==6) {$month_txt="June"}
elsif ($_==7) {$month_txt="July"}
elsif ($_==8) {$month_txt="August"}
elsif ($_==9) {$month_txt="September"}
elsif ($_==10) {$month_txt="October"}
elsif ($_==11) {$month_txt="November"}
elsif ($_==12) {$month_txt="December"}
else {$month_txt="ERROR"};
                }



